package sun.awt.image;

import java.awt.image.ImageConsumer;

class ConsumerQueue {
   ImageConsumer consumer;
   Thread feeder;
   ImageDecoder decoder;
   ConsumerQueue next;
   boolean interested;
   Object securityContext;
   boolean secure;

   ConsumerQueue(InputStreamImageSource var1, ImageConsumer var2) {
      this.consumer = var2;
      this.interested = true;
      if (var2 instanceof ImageRepresentation) {
         ImageRepresentation var5 = (ImageRepresentation)var2;
         if (var5.image.source != var1) {
            throw new SecurityException("ImageRep added to wrong image source");
         } else {
            this.secure = true;
         }
      } else if (var2 instanceof ImageInfoGrabber) {
         ImageInfoGrabber var4 = (ImageInfoGrabber)var2;
         if (var4.image.source != var1) {
            throw new SecurityException("ImageRep added to wrong image source");
         } else {
            this.secure = true;
         }
      } else {
         SecurityManager var3 = System.getSecurityManager();
         if (var3 != null) {
            this.securityContext = var3.getSecurityContext();
         } else {
            this.securityContext = null;
         }
      }
   }

   public String toString() {
      return "[" + this.consumer + " " + this.securityContext + "]";
   }
}
