package sun.awt.motif;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Font;
import java.awt.Insets;
import java.awt.Window;
import java.awt.peer.DialogPeer;
import java.util.Vector;

class MDialogPeer extends MPanelPeer implements DialogPeer {
   Insets insets;
   Thread currentThread;
   static Vector allDialogs = new Vector();

   native void create(MComponentPeer var1, Object var2);

   native void pSetTitle(String var1);

   native void pShow();

   native void pHide();

   native void pReshape(int var1, int var2, int var3, int var4);

   native void pDispose();

   public native void setResizable(boolean var1);

   MDialogPeer(Dialog var1) {
      super(var1, new Insets(Integer.getInteger("awt.frame.topInset", 25), Integer.getInteger("awt.frame.leftInset", 5), Integer.getInteger("awt.frame.bottomInset", 5), Integer.getInteger("awt.frame.rightInset", 5)));
      allDialogs.addElement(this);
      MFramePeer var2 = (MFramePeer)((Component)var1).getParent().getPeer();
      if (var2 != null) {
         var2.addWindow(var1);
      }

      if (var1.getTitle() != null) {
         this.pSetTitle(var1.getTitle());
      }

      Font var3 = ((Component)var1).getFont();
      if (var3 == null) {
         var3 = new Font("Dialog", 0, 12);
         ((Component)var1).setFont(var3);
         ((MComponentPeer)this).setFont(var3);
      }

      Color var4 = ((Component)var1).getBackground();
      if (var4 == null) {
         ((Component)var1).setBackground(Color.lightGray);
         ((MComponentPeer)this).setBackground(Color.lightGray);
      }

      var4 = ((Component)var1).getForeground();
      if (var4 == null) {
         ((Component)var1).setForeground(Color.black);
         ((MComponentPeer)this).setForeground(Color.black);
      }

      this.setResizable(var1.isResizable());
   }

   public void show() {
      if (!((Dialog)super.target).isModal()) {
         super.show();
      } else {
         this.currentThread = Thread.currentThread();
         if (super.applet != null && this.currentThread == super.applet.getAppletThread()) {
            this.pShow();
            super.applet.enterModal();
         } else {
            this.pShow();
            Component var1 = super.target;
            synchronized(var1){}

            try {
               try {
                  super.target.wait(0L);
               } catch (InterruptedException var4) {
               }
            } catch (Throwable var5) {
               throw var5;
            }
         }

         this.currentThread = null;
      }
   }

   public void hide() {
      if (((Dialog)super.target).isModal() && this.currentThread != null) {
         if (super.applet != null && this.currentThread == super.applet.getAppletThread()) {
            super.applet.exitModal();
         } else {
            Component var1 = super.target;
            synchronized(var1){}

            try {
               try {
                  super.target.notifyAll();
               } catch (IllegalMonitorStateException var4) {
               }
            } catch (Throwable var5) {
               throw var5;
            }
         }

         this.pHide();
      } else {
         super.hide();
      }
   }

   public void setTitle(String var1) {
      this.pSetTitle(var1);
   }

   public void dispose() {
      MFramePeer var1 = (MFramePeer)super.target.getParent().getPeer();
      if (var1 != null) {
         var1.removeWindow((Window)super.target);
      }

      allDialogs.removeElement(this);
      this.hide();
      super.dispose();
   }

   public synchronized void handleMoved(int var1, int var2) {
      if (super.applet != null) {
         XEvent var3 = new XEvent(new Event(super.target, 0L, 205, var1, var2, 0, 0), this);
         super.applet.sendEvent(var3);
      } else {
         super.target.postEvent(new Event(super.target, 0L, 205, var1, var2, 0, 0));
      }
   }

   public void handleQuit() {
      if (super.applet != null) {
         XEvent var1 = new XEvent(new Event(super.target, 201, (Object)null), this);
         super.applet.sendEvent(var1);
      } else {
         super.target.postEvent(new Event(super.target, 201, (Object)null));
      }
   }

   public void handleIconify() {
      if (super.applet != null) {
         XEvent var1 = new XEvent(new Event(super.target, 203, (Object)null), this);
         super.applet.sendEvent(var1);
      } else {
         super.target.postEvent(new Event(super.target, 203, (Object)null));
      }
   }

   public void handleDeiconify() {
      if (super.applet != null) {
         XEvent var1 = new XEvent(new Event(super.target, 204, (Object)null), this);
         super.applet.sendEvent(var1);
      } else {
         super.target.postEvent(new Event(super.target, 204, (Object)null));
      }
   }

   public void toFront() {
      this.pShow();
   }

   public native void toBack();

   public Insets insets() {
      return this.insets;
   }

   public synchronized void handleResize(int var1, int var2) {
      if (super.applet != null) {
         XEvent var3 = new XEvent(new Event(super.target, 207, (Object)null), this);
         super.applet.sendEvent(var3);
      } else {
         super.target.invalidate();
         super.target.validate();
         super.target.repaint();
      }
   }
}
