package sun.awt.motif;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.peer.TextAreaPeer;

public class MTextAreaPeer extends MComponentPeer implements TextAreaPeer {
   native void create(MComponentPeer var1);

   void initialize() {
      TextArea var1 = (TextArea)super.target;
      String var2;
      if ((var2 = ((TextComponent)var1).getText()) != null) {
         this.setText(var2);
      }

      this.select(((TextComponent)var1).getSelectionStart(), ((TextComponent)var1).getSelectionEnd());
      this.setEditable(((TextComponent)var1).isEditable());
      super.initialize();
   }

   public MTextAreaPeer(TextArea var1) {
      super(var1);
   }

   public void setEditable(boolean var1) {
      this.pSetEditable(var1);
      this.setBackground(super.target.getBackground());
   }

   public void setBackground(Color var1) {
      TextArea var2 = (TextArea)super.target;
      super.setBackground(var1);
      if (((TextComponent)var2).isEditable()) {
         this.setTextBackground(var1.brighter());
      }

   }

   native int getExtraWidth();

   native int getExtraHeight();

   public native void setTextBackground(Color var1);

   public native void pSetEditable(boolean var1);

   public native void select(int var1, int var2);

   public native int getSelectionStart();

   public native int getSelectionEnd();

   public native void setText(String var1);

   public native String getText();

   public native void insertText(String var1, int var2);

   public native void replaceText(String var1, int var2, int var3);

   public native void setFont(Font var1);

   public Dimension minimumSize() {
      return this.minimumSize(10, 60);
   }

   public Dimension preferredSize(int var1, int var2) {
      return this.minimumSize(var1, var2);
   }

   public Dimension minimumSize(int var1, int var2) {
      FontMetrics var3 = ((MComponentPeer)this).getFontMetrics(super.target.getFont());
      int var4 = var3.charWidth('0');
      int var5 = var3.getHeight() - var3.getLeading();
      return new Dimension(var2 * var4 + this.getExtraWidth(), var1 * var5 + this.getExtraHeight());
   }
}
