package sun.awt.motif;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.FontMetrics;
import java.awt.TextComponent;
import java.awt.TextField;
import java.awt.peer.TextFieldPeer;

public class MTextFieldPeer extends MComponentPeer implements TextFieldPeer {
   native void create(MComponentPeer var1);

   void initialize() {
      TextField var1 = (TextField)super.target;
      this.setText(((TextComponent)var1).getText());
      if (var1.echoCharIsSet()) {
         this.setEchoCharacter(var1.getEchoChar());
      }

      this.select(((TextComponent)var1).getSelectionStart(), ((TextComponent)var1).getSelectionEnd());
      this.setEditable(((TextComponent)var1).isEditable());
      super.initialize();
   }

   public MTextFieldPeer(TextField var1) {
      super(var1);
   }

   public void setEditable(boolean var1) {
      this.pSetEditable(var1);
      this.setBackground(super.target.getBackground());
   }

   public void setBackground(Color var1) {
      TextField var2 = (TextField)super.target;
      if (((TextComponent)var2).isEditable()) {
         var1 = var1.brighter();
      }

      super.setBackground(var1);
   }

   public native void pSetEditable(boolean var1);

   public native void select(int var1, int var2);

   public native int getSelectionStart();

   public native int getSelectionEnd();

   public native void setText(String var1);

   public native void dispose();

   public native String getText();

   public native void setEchoCharacter(char var1);

   public Dimension minimumSize() {
      X11FontMetrics var1 = (X11FontMetrics)((MComponentPeer)this).getFontMetrics(super.target.getFont());
      Dimension var2 = var1.stringExtent(((TextField)super.target).getText());
      var2.width += 20;
      var2.height += 15;
      return var2;
   }

   public Dimension preferredSize(int var1) {
      return this.minimumSize(var1);
   }

   public Dimension minimumSize(int var1) {
      FontMetrics var2 = ((MComponentPeer)this).getFontMetrics(super.target.getFont());
      return new Dimension(var2.charWidth('0') * var1 + 20, var2.getHeight() + 15);
   }

   public void action() {
      if (super.applet != null) {
         XEvent var1 = new XEvent(new Event(super.target, 1001, ((TextField)super.target).getText()), this);
         super.applet.sendEvent(var1);
      } else {
         super.target.postEvent(new Event(super.target, 1004, (Object)null));
      }
   }
}
