package sun.awt.motif;

import java.awt.Color;
import java.awt.Component;
import java.awt.Event;
import java.awt.Font;
import java.awt.Insets;
import java.awt.Window;
import java.awt.peer.WindowPeer;
import java.util.Vector;

class MWindowPeer extends MPanelPeer implements WindowPeer {
   Insets insets = new Insets(0, 0, 0, 0);
   static Vector allWindows = new Vector();

   native void create(MComponentPeer var1);

   native void pShow();

   native void pHide();

   native void pReshape(int var1, int var2, int var3, int var4);

   native void pDispose();

   MWindowPeer(Window var1) {
      super(var1);
      allWindows.addElement(this);
      MFramePeer var2 = (MFramePeer)((Component)var1).getParent().getPeer();
      if (var2 != null) {
         var2.addWindow(var1);
      }

      Font var3 = ((Component)var1).getFont();
      if (var3 == null) {
         var3 = new Font("Dialog", 0, 12);
         ((Component)var1).setFont(var3);
         ((MComponentPeer)this).setFont(var3);
      }

      Color var4 = ((Component)var1).getBackground();
      if (var4 == null) {
         ((Component)var1).setBackground(Color.lightGray);
         ((MComponentPeer)this).setBackground(Color.lightGray);
      }

      var4 = ((Component)var1).getForeground();
      if (var4 == null) {
         ((Component)var1).setForeground(Color.black);
         ((MComponentPeer)this).setForeground(Color.black);
      }

   }

   public void dispose() {
      MFramePeer var1 = (MFramePeer)super.target.getParent().getPeer();
      if (var1 != null) {
         var1.removeWindow((Window)super.target);
      }

      allWindows.removeElement(this);
      super.dispose();
   }

   public void toFront() {
      this.pShow();
   }

   public native void toBack();

   public Insets insets() {
      return this.insets;
   }

   public void handleQuit() {
      if (super.applet != null) {
         XEvent var1 = new XEvent(new Event(super.target, 201, (Object)null), this);
         super.applet.sendEvent(var1);
      } else {
         super.target.postEvent(new Event(super.target, 201, (Object)null));
      }
   }

   public void handleIconify() {
      if (super.applet != null) {
         XEvent var1 = new XEvent(new Event(super.target, 203, (Object)null), this);
         super.applet.sendEvent(var1);
      } else {
         super.target.postEvent(new Event(super.target, 203, (Object)null));
      }
   }

   public void handleDeiconify() {
      if (super.applet != null) {
         XEvent var1 = new XEvent(new Event(super.target, 204, (Object)null), this);
         super.applet.sendEvent(var1);
      } else {
         super.target.postEvent(new Event(super.target, 204, (Object)null));
      }
   }

   public synchronized void handleResize(int var1, int var2) {
      if (super.applet != null) {
         XEvent var3 = new XEvent(new Event(super.target, 207, (Object)null), this);
         super.applet.sendEvent(var3);
      } else {
         super.target.invalidate();
         super.target.validate();
         super.target.repaint();
      }
   }
}
