package sun.awt.motif;

import java.awt.Component;
import java.awt.Event;
import java.awt.Graphics;
import java.awt.MenuComponent;
import java.awt.MenuItem;
import java.awt.Rectangle;
import netscape.applet.NEvent;
import sun.awt.ObjectPeer;

public class XEvent extends NEvent {
   public static final int WINDOW_REPAINT = 206;
   public static final int WINDOW_RESIZE = 207;
   public static final int ACTION_MENU = 300;
   Event pJavaEvent;
   ObjectPeer peer;

   public XEvent(Event var1, MComponentPeer var2) {
      super(20);
      this.peer = var2;
      this.pJavaEvent = var1;
   }

   public XEvent(Event var1, MMenuItemPeer var2) {
      super(20);
      this.peer = var2;
      this.pJavaEvent = var1;
   }

   public void processEvent() {
      Object var1 = null;
      switch (this.pJavaEvent.id) {
         case 201:
         case 203:
         case 204:
         case 205:
         case 501:
         case 502:
         case 503:
         case 504:
         case 505:
         case 506:
         case 1001:
         case 1004:
         case 1005:
            Component var16 = (Component)this.pJavaEvent.target;
            var16.postEvent(this.pJavaEvent);
            return;
         case 202:
            Component var15 = (Component)this.pJavaEvent.target;
            Rectangle var20 = (Rectangle)this.pJavaEvent.arg;
            Graphics var18 = var15.getGraphics();
            if (var18 != null) {
               try {
                  var18.clipRect(var20.x, var20.y, var20.width, var20.height);
                  ((MComponentPeer)this.peer).paint(var18);
               } finally {
                  var18.dispose();
               }

               return;
            }
            break;
         case 206:
            Component var14 = (Component)this.pJavaEvent.target;
            Rectangle var19 = (Rectangle)this.pJavaEvent.arg;
            Graphics var2 = var14.getGraphics();
            if (var2 != null) {
               try {
                  var2.clipRect(var19.x, var19.y, var19.width, var19.height);
                  ((MComponentPeer)this.peer).update(var2);
               } finally {
                  var2.dispose();
               }

               return;
            }
            break;
         case 207:
            Component var13 = (Component)this.pJavaEvent.target;
            var13.invalidate();
            var13.validate();
            var13.repaint();
         default:
            Component var17 = (Component)this.pJavaEvent.target;
            var17.postEvent(this.pJavaEvent);
            break;
         case 300:
            MenuItem var3 = (MenuItem)this.pJavaEvent.target;
            this.pJavaEvent.id = 1001;
            ((MenuComponent)var3).postEvent(this.pJavaEvent);
            return;
         case 401:
         case 402:
         case 403:
         case 404:
            Component var12 = (Component)this.pJavaEvent.target;
            var12.postEvent(this.pJavaEvent);
            ((MComponentPeer)this.peer).disposeEvent(this.pJavaEvent);
            return;
      }

   }

   public Object getTarget() {
      return this.peer;
   }
}
